stages:
  - cmake
  - lib
  - build
  - test
  - analyze
  - deploy

image: $CI_REGISTRY/cpp2/cpp_libs/mylib_cpp

include:
  - template: Code-Quality.gitlab-ci.yml

cmake:
  stage: cmake
  script:
    - git clone https://gitlab-ci-token:${CI_JOB_TOKEN}@gitlab.com/cpp2/cpp_cmake_install_script.git
    - ./cpp_cmake_install_script/install_script.sh
    - DEBIAN_FRONTEND=noninteractive apt install -y wget
    - mkdir install
    - 'wget --header="JOB-TOKEN: $CI_JOB_TOKEN" ${CI_API_V4_URL}/projects/14697498/packages/generic/library/0.1.0/lib.tar.gz'
    - tar -xzvf lib.tar.gz -C install
    - rm lib.tar.gz
    - 'wget --header="JOB-TOKEN: $CI_JOB_TOKEN" ${CI_API_V4_URL}/projects/12846507/packages/generic/library/0.1.0/lib.tar.gz'
    - tar -xzvf lib.tar.gz -C install
    - rm lib.tar.gz
    - make cmake INCLUDE_PATH_REL_OVERRIDE=install
  artifacts:
    expire_in: 20 minutes
    paths:
      - build
      - install
      - lib
      - bin
      - cpp_cmake_install_script
      - makefile
      - CMakeLists.txt
      - FILES_MAIN/CMakeLists.txt
      - FILES_LIB/CMakeLists.txt
      - TEST/CMakeLists.txt
      - TEST/CodeCoverage.cmake

lib:
  stage: lib
  dependencies:
    - cmake
  script:
    - make lib
    - make install
    - cd install && tar -czf ../lib.tar.gz .
  artifacts:
    expire_in: 20 minutes
    paths:
      - lib.tar.gz
      - build
      - lib

executables_build:
  stage: build
  dependencies:
    - lib
    - cmake
  script:
    - make exec
  artifacts:
    expire_in: 20 minutes
    paths:
      - bin

googletests_build:
  stage: build
  dependencies:
    - lib
    - cmake
  script:
    - make googletests
  artifacts:
    paths:
      - build
      - bin/

googletests:
  stage: test
  script:
    - ./bin/googletests --gtest_output="xml:testresults.xml"
  dependencies:
    - googletests_build
  needs:
    - googletests_build
  artifacts:
    when: always
    reports:
      junit: testresults.xml

executables:
  stage: test
  script:
    - find bin -type f -not -name "googletests" -exec {} \;
  dependencies:
    - executables_build
  needs:
    - executables_build

code_quality:
  stage: analyze
  artifacts:
    paths: [gl-code-quality-report.json]
  rules:
    - if: $CI_MERGE_REQUEST_ID
  dependencies: []

coverage:
  stage: analyze
  dependencies: 
    - googletests_build
    - lib
    - cmake
  needs:
    - googletests_build
    - lib
    - cmake
  script:
    - make coverage
  artifacts:
    paths:
      - build/coverage/

release:
  image: curlimages/curl:latest
  stage: deploy
  needs:
    - lib
  dependencies:
    - lib
  rules:
    - if: $CI_COMMIT_TAG
  script:
    - 'curl --header "JOB-TOKEN: $CI_JOB_TOKEN" --upload-file lib.tar.gz "${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/generic/library/${CI_COMMIT_TAG}/lib.tar.gz"'

pages:
  image: ruby:latest
  stage: deploy
  dependencies:
    - coverage
  needs:
    - coverage
  script:
    - ls -lah
    - mv build/coverage/ public/
  artifacts:
    paths:
      - public
    expire_in: never
  only:
    - master
